unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids, StdCtrls, ExtCtrls, Spin;

type
  TForm2 = class(TForm)
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    ShowHideData1: TMenuItem;
    drawdistribution: TButton;
    Image1: TImage;
    Edit3: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    ReDraw1: TMenuItem;
    SpinEdit1: TSpinEdit;
    procedure Exit1Click(Sender: TObject);
    procedure ShowHideData1Click(Sender: TObject);
    procedure drawdistributionClick(Sender: TObject);
    procedure ReDraw1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.DFM}

function fx (x: extended): integer;
  begin
   fx := round(gwidth * (x - gxmin) / (gxmax - gxmin));
  end;

function fy (y: extended): integer;
  begin
   fy := gheight - round(gheight * (y - gymin) / (gymax - gymin));
  end;

procedure TForm2.Exit1Click(Sender: TObject);
begin
  Form2.Visible := False;
  Form2.Hide;
end;

procedure TForm2.ShowHideData1Click(Sender: TObject);
begin
  If StringGrid1.Visible <> true then
    begin
      StringGrid1.Visible := True;
    end
      else
    begin
      StringGrid1.Visible := False;
    end;

end;

procedure TForm2.drawdistributionClick(Sender: TObject);
var
  ii,jj : integer;
  xx,yy : extended;
begin
  with Form2.Image1 do
    begin

      dxmin := StrToFloat(Form2.Edit1.Text);
      dxmax := StrToFloat(Form2.Edit2.Text);
      dymin := StrToFloat(Form2.Edit3.Text);
      dymax := Form2.SpinEdit1.Value;

      gxmin := dxmin - (dxmax-dxmin)*0.05;
      gxmax := dxmax + (dxmax-dxmin)*0.05;
      gymin := dymin - (dymax-dymin)*0.05;
      gymax := dymax + (dymax-dymin)*0.05;

      gheight := Form2.Image1.Height;
      gwidth := Form2.Image1.Width;

      with Canvas do
        begin
          Brush.Color := clWhite;
          Rectangle(fx(gxmin),fy(gymin),fx(gxmax),fy(gymax));

          Pen.Width := 1;
          Pen.Color := clGreen;
          Rectangle(fx(dxmin), fy(dymin), fx(dxmax),fy(dymax));


          Pen.Width := 1;
          maru := 3;


          for ii := 2 to Form2.StringGrid1.ColCount-1 do
            begin
              case ii mod 7 of
              0 : Pen.Color := clRed;
              1 : Pen.Color := clBlue;
              2 : Pen.Color := clGreen;
              3 : Pen.Color := clblack;
              4 : Pen.Color := clyellow;
              5 : Pen.Color := clpurple;
              6 : Pen.Color := clblue;
              end;
              xx := StrToFloat(Form2.StringGrid1.Cells[0,1]);
              yy := StrToFloat(Form2.StringGrid1.Cells[ii,1]);
              MoveTo(fx(xx), fy(yy));
              Ellipse(fx(xx)-maru, fy(yy)-maru, fx(xx)+maru, fy(yy)+maru);
              for jj := 1 to Form2.StringGrid1.RowCount-1 do
                begin
                  xx := StrToFloat(Form2.StringGrid1.Cells[0,jj]);
                  yy := StrToFloat(Form2.StringGrid1.Cells[ii,jj]);
                  LineTo(fx(xx), fy(yy));
                  Ellipse(fx(xx)-maru, fy(yy)-maru, fx(xx)+maru, fy(yy)+maru);
                end;
            end;
        end;

    end;


end;

procedure TForm2.ReDraw1Click(Sender: TObject);
begin
  Form2.drawdistributionClick(Sender);
end;

end.
