unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, Menus;

type
  TForm3 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    StringGrid2: TStringGrid;
    Open1: TMenuItem;
    selectcol: TSpinEdit;
    selectrow: TSpinEdit;
    cellvalue: TEdit;
    Adopt: TButton;
    OpenDialog1: TOpenDialog;
    Model_1: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    katamuki: TSpinEdit;
    GroupBox3: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    a_value: TEdit;
    Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure StringGrid2SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure AdoptClick(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure katamukiChange(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form3: TForm3;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm3.Exit1Click(Sender: TObject);
begin
  Form3.Hide;
end;

procedure TForm3.StringGrid2SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  Form3.selectcol.value := ACol;
  Form3.selectrow.value := ARow;
  Form3.cellvalue.text := Form3.StringGrid2.Cells[Form3.selectcol.value,Form3.selectrow.value];
end;

procedure TForm3.AdoptClick(Sender: TObject);
begin
  Form3.StringGrid2.Cells[Form3.selectcol.value,Form3.selectrow.value] := Form3.cellvalue.text;
end;

procedure TForm3.Open1Click(Sender: TObject);
var
  ii : integer;
  FileDum5 : string;
begin
  OpenDialog1.InitialDir := dirinfo;
  With OpenDialog1 do
  if Execute then
    begin
      FileDum5 := FileName;
      AssignFile(txt,FileDum5);
      Reset(txt);
      ii := -1;
      while not eof(txt) do
       begin
        ii := ii + 1;
        readln(txt, scl[ii]);
       end;
      CloseFile(txt);
      nscl := ii+1;

      if ndata <> Form1.SpinEdit1.value then
        begin
          ShowMessage('The number of components do not match with that defined with AXn in Page 1. Check and correct!!!');
        end;

      Form3.StringGrid2.RowCount := nscl+1;

      Form3.StringGrid2.Cells[0,0] := 'Species';
      Form3.StringGrid2.Cells[1,0] := 'Scaling Factor';
      for ii := 0 to nscl-1 do
        begin
          Form3.StringGrid2.Cells[0,ii+1] := 'AX'+IntToSTr(ii)+'^'+IntToStr(nscl-ii)+'+';
          Form3.StringGrid2.Cells[1,ii+1] := FloatToStr(scl[ii]);
        end;
    end;

end;

procedure TForm3.katamukiChange(Sender: TObject);
var
  ii : integer;
begin
  for ii := 1 to Form3.StringGrid2.RowCount-1 do
    begin
      Form3.StringGrid2.Cells[1,ii] := FloatToStr(1+(ii-1)*Form3.katamuki.value/100);
      scl[ii-1] := 1+(ii-1)*Form3.katamuki.value/100;
    end;
end;

procedure TForm3.Button6Click(Sender: TObject);
var
  ii : integer;
begin
  if StrToFloat(Form3.a_value.text) <> 0 then
  begin
  for ii := 1 to Form3.StringGrid2.RowCount-1 do
    begin
      Form3.StringGrid2.Cells[1,ii]
      := FloatToStr(StrToFloat(Form3.a_value.text)/(ii-1+StrToFloat(Form3.a_value.text)));
      scl[ii-1] := StrToFloat(Form3.a_value.text)/(ii-1+StrToFloat(Form3.a_value.text));
    end;
  end else showmessage('The value of a should not be zero!!!  A zero division error occurs!!!');
end;

end.
